# mypy-boto3-gamelift

[![PyPI - mypy-boto3-gamelift](https://img.shields.io/pypi/v/mypy-boto3-gamelift.svg?color=blue)](https://pypi.org/project/mypy-boto3-gamelift)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-gamelift.svg?color=blue)](https://pypi.org/project/mypy-boto3-gamelift)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-gamelift](#mypy-boto3-gamelift)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.GameLift 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/gamelift.html#GameLift) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.3](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-gamelift](#mypy-boto3-gamelift)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `GameLift` service.

```bash
python -m pip install boto3-stubs[gamelift]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_gamelift` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_gamelift import GameLiftClient

# Now mypy can check if your code is valid.
client: GameLiftClient = boto3.client("gamelift")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: GameLiftClient = session.client("gamelift")



# Annotated paginators are included as well

import mypy_boto3_gamelift.paginator as gamelift_paginators

describe_fleet_attributes_paginator: gamelift_paginators.DescribeFleetAttributesPaginator = client.get_paginator("describe_fleet_attributes")
describe_fleet_capacity_paginator: gamelift_paginators.DescribeFleetCapacityPaginator = client.get_paginator("describe_fleet_capacity")
describe_fleet_events_paginator: gamelift_paginators.DescribeFleetEventsPaginator = client.get_paginator("describe_fleet_events")
describe_fleet_utilization_paginator: gamelift_paginators.DescribeFleetUtilizationPaginator = client.get_paginator("describe_fleet_utilization")
describe_game_session_details_paginator: gamelift_paginators.DescribeGameSessionDetailsPaginator = client.get_paginator("describe_game_session_details")
describe_game_session_queues_paginator: gamelift_paginators.DescribeGameSessionQueuesPaginator = client.get_paginator("describe_game_session_queues")
describe_game_sessions_paginator: gamelift_paginators.DescribeGameSessionsPaginator = client.get_paginator("describe_game_sessions")
describe_instances_paginator: gamelift_paginators.DescribeInstancesPaginator = client.get_paginator("describe_instances")
describe_matchmaking_configurations_paginator: gamelift_paginators.DescribeMatchmakingConfigurationsPaginator = client.get_paginator("describe_matchmaking_configurations")
describe_matchmaking_rule_sets_paginator: gamelift_paginators.DescribeMatchmakingRuleSetsPaginator = client.get_paginator("describe_matchmaking_rule_sets")
describe_player_sessions_paginator: gamelift_paginators.DescribePlayerSessionsPaginator = client.get_paginator("describe_player_sessions")
describe_scaling_policies_paginator: gamelift_paginators.DescribeScalingPoliciesPaginator = client.get_paginator("describe_scaling_policies")
list_aliases_paginator: gamelift_paginators.ListAliasesPaginator = client.get_paginator("list_aliases")
list_builds_paginator: gamelift_paginators.ListBuildsPaginator = client.get_paginator("list_builds")
list_fleets_paginator: gamelift_paginators.ListFleetsPaginator = client.get_paginator("list_fleets")
search_game_sessions_paginator: gamelift_paginators.SearchGameSessionsPaginator = client.get_paginator("search_game_sessions")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_gamelift` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_gamelift as gamelift
from mypy_boto3_gamelift import GameLiftClient

# with these
from mypy_boto3 import gamelift
from mypy_boto3.gamelift import GameLiftClient
```